--- temp/xemacs-beta/src/specifier.c	2012-12-31 02:28:54.000000000 -0500
+++ specifier.c	2012-12-31 02:31:52.000000000 -0500
@@ -3424,14 +3424,18 @@
      always create a new copy. Thus EQ will always fail. Unfortunately
      calling equal is no good either as this doesn't take into account
      things attached to the specifier - for instance strings on
-     extents. --andyp */
+     extents. --andyp
+     This check also prevents explicit dirty-flag sets using
+     (`set-specifier-dirty-flag'). These are necesary for updating
+     display of specifiers whose appearance depends on arbitrary forms.
+     (eg. toolbar icons, active-p forms, etc.)  --byrelm */
-  if (!EQ (newval, *location) || XSPECIFIER (specifier)->caching->always_recompute)
-    {
+  //if (!EQ (newval, *location) || XSPECIFIER (specifier)->caching->always_recompute)
+  //  {
       oldval = *location;
       *location = newval;
       (XSPECIFIER (specifier)->caching->value_changed_in_window)
 	(specifier, w, oldval);
-    }
+  //  }
 }
 
 static void
@@ -3453,13 +3457,14 @@
      method. */
   location = (Lisp_Object *)
     ((char *) f + XSPECIFIER (specifier)->caching->offset_into_struct_frame);
-  if (!EQ (newval, *location) || XSPECIFIER (specifier)->caching->always_recompute)
-    {
+  /* See comment on recompute_one_cached_specifier_in_window */
+  //  if (!EQ (newval, *location) || XSPECIFIER (specifier)->caching->always_recompute)
+  //    {
       oldval = *location;
       *location = newval;
       (XSPECIFIER (specifier)->caching->value_changed_in_frame)
 	(specifier, f, oldval);
-    }
+  //    }
 }
 
 void
